//=============================================================================
// ServerBeacon: Broadcasts a LAN beacon so clients can find the server.
//=============================================================================
class ServerBeacon expands UdpBeacon
	transient;

function BeginPlay()
{
	if ( BindPort(ServerBeaconPort) )
	{
		log( "ServerBeacon initialized." );
	}
	else
	{
		log( "ServerBeacon failed: Could not bind port." );
	}

	BroadcastBeacon(); // Initial notification.
}

function BroadcastBeacon()
{
	local IpAddr Addr;
	local string[240] BeaconText;

	Log("Broadcasting Beacon");

	Addr.Addr = BroadcastAddr;
	Addr.Port = BeaconPort;
	Level.Game.GetBeaconText( BeaconText );
	SendText( Addr, BeaconProduct $ " " $ Level.GetAddressURL() $ " " $ BeaconText );
}

event ReceivedText( IpAddr Addr, string[240] Text )
{
	if ( Text == "REPORT" )
	{
		BroadcastBeacon();
	}
}

defaultproperties
{
}
