//=============================================================================
// TelePingTrigger.
//=============================================================================
class TelePingTrigger expands Triggers;

var TeleporterPinger Pinger;
var string[64] URL;

// Create the Teleporter Pinger and get the related Teleporter's URL
function BeginPlay()
{
	local Teleporter Tele;
	
	Pinger = Spawn(class'TeleporterPinger', self);
	if( Event != '' )
	{
		// Each TelePingTrigger should relate to only ONE Teleporter.
		// As such, just take whichever matches and run with it.
		foreach AllActors( class 'Teleporter', Tele, Event )
			URL = Tele.URL;
	}
		
	Pinger.InitializeInfo( URL );
}

// Called when something touches the trigger.
// TelePingTriggers are never touch once only.
function Touch( actor Other )
{
	if (Other.IsA('PlayerPawn'))
		Pinger.ReportStats( Other );
}

defaultproperties
{
}
